﻿<?xml version="1.0" encoding="utf-8"?>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd" MadCap:onlyLocalStylesheets="False">
    <head>
        <link href="../Resources/TableStyles/Default-Table.css" rel="stylesheet" MadCap:stylesheetType="table" /><title>Uploading Users using File Based Method</title>
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" type="text/css" />
    </head>
    <body>
        <h1>Uploading Users using File Based Method</h1>
        <p>This section provides information about uploading users through CSV file. You can upload new users or update the attributes of existing users via a CSV file through&#160;Admin or ARS interfaces of the Identity Governance and Administration (IGA).&#160;</p>
        <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
            <p class="note">Currently, uploading user data via ARS is not supported in Release v5.5.3.x.</p>
        </div>
        <h2>Prerequisites for ARS</h2>
        <p>Ensure that the SAV role assigned to the user who will perform the upload has the ‘Upload User’ privilege. To verify it, go to <strong>SAV_ROLE &gt; Create Request Home Option</strong> and select <strong>Upload User Request</strong>.</p>
        <p>
            <img src="../Resources/Images/47.png" style="border-left-style: solid;border-left-width: 1px;border-left-color: ;border-right-style: solid;border-right-width: 1px;border-right-color: ;border-top-style: solid;border-top-width: 1px;border-top-color: ;border-bottom-style: solid;border-bottom-width: 1px;border-bottom-color: ;" />
            <br />
        </p>
        <p>IGA provides a&#160;<a href="../Resources/Attachments/user import_sample.csv">sample CSV file</a>&#160;containing example values for users. To upload users, download this file to your server, modify its details, and upload it to IGA.&#160;The sample file includes different parameters to specify the user details:&#160;</p>
        <div class="table-wrap">
            <table style="width: 100%;mc-table-style: url('../Resources/TableStyles/Default-Table.css');" class="TableStyle-Default-Table" cellspacing="0">
                <col class="TableStyle-Default-Table-Column-Column1" />
                <col class="TableStyle-Default-Table-Column-Column1" />
                <thead>
                    <tr class="TableStyle-Default-Table-Head-Header1">
                        <th class="TableStyle-Default-Table-HeadE-Column1-Header1">Parameter</th>
                        <th class="TableStyle-Default-Table-HeadD-Column1-Header1">Description</th>
                    </tr>
                </thead>
                <tbody>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">USERNAME</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the user name for the user.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">CUSTOMPROPERTY</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the&#160;custom property value for the user.&#160;</p>
                            <p style="text-align: left;" class="table-text">For example, CORPORATE ACCOUNT MANAGEMENT for the department or cost centre of the user.</p>
                            <p style="text-align: left;" class="table-text">Custom properties can also be used for updating the status of a user. For example, Active.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">STATUSKEY</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p style="text-align: left;" class="table-text">Specify the status value to mark the user's status.&#160;The below options can be configured:</p>
                            <ul>
                                <li>
                                    <p class="table-text"><strong>0</strong>: Inactive (Indicates that the current status of the user is inactive)</p>
                                </li>
                                <li>
                                    <p class="table-text"><strong>1</strong>: Active (Indicates that the current status of the user is active)</p>
                                </li>
                            </ul>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">DEPARTMENTNAME</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the department name of the user.&#160;For example, CORPORATE.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">OWNER</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the name of the owner associated with a manager.</p>
                            <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                                <p class="note">When a user's owner is uploaded, it is displayed as the user's owner in&#160;<strong style="text-align: left;">Other Attributes &gt; Owner</strong>. Note that a user's owner is also considered as the manager of the user in IGA.</p>
                            </div>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">EMAIL</p>
                        </td>
                        <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the email ID of the user.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                            <p class="table-text">FIRSTNAME</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                            <p class="table-text">Specify the first name of the user.</p>
                        </td>
                    </tr>
                    <tr class="TableStyle-Default-Table-Body-Body1">
                        <td colspan="1" class="TableStyle-Default-Table-BodyB-Column1-Body1">
                            <p class="table-text">LASTNAME</p>
                        </td>
                        <td colspan="1" class="TableStyle-Default-Table-BodyA-Column1-Body1">
                            <p class="table-text">Specify the last name of the user.</p>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
        <p>To upload users using Admin or ARS, perform the following steps:</p>
        <ol>
            <li>Click <strong>Admin &gt; Identity Repository &gt; Users &gt; Actions &gt; Upload User</strong>  or <strong>ARS &gt; Upload User Request</strong>.</li>
            <li>
                <p class="auto-cursor-target">In the <strong>Select File to Upload User</strong>&#160;pop-up window that displays, specify the following parameters.</p>
                <div class="table-wrap">
                    <table style="width: 100%;mc-table-style: url('../Resources/TableStyles/Default-Table.css');" class="TableStyle-Default-Table" cellspacing="0">
                        <col style="width: 270px;" class="TableStyle-Default-Table-Column-Column1" />
                        <col style="width: 78.7838%;" class="TableStyle-Default-Table-Column-Column1" />
                        <thead>
                            <tr class="TableStyle-Default-Table-Head-Header1">
                                <th class="TableStyle-Default-Table-HeadE-Column1-Header1">Parameter</th>
                                <th class="TableStyle-Default-Table-HeadD-Column1-Header1">Description</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Data File</p>
                                </td>
                                <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Upload the CSV file with user details using the&#160;<strong style="text-decoration: none;text-align: left;">Select</strong> button. <br class="atl-forced-newline" style="text-decoration: none;text-align: left;" />After the file is uploaded, the file name is displayed.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Delimiter</p>
                                </td>
                                <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Select the delimiter&#160;to be used in the data file being uploaded. <br class="atl-forced-newline" style="text-decoration: none;text-align: left;" /> The options are: </p>
                                    <ul>
                                        <li>
                                            <p class="table-text">Comma</p>
                                        </li>
                                        <li>
                                            <p class="table-text">Pipe</p>
                                        </li>
                                        <li>
                                            <p class="table-text">Tab</p>
                                        </li>
                                    </ul>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">First row as heading</p>
                                </td>
                                <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Specify whether you want to&#160;use the&#160;first row in the CSV file as the heading.</p>
                                    <p class="table-text">The options are:</p>
                                    <ul>
                                        <li>
                                            <p class="table-text"><strong>Yes: </strong>Uses the&#160;first row as the heading.&#160;</p>
                                        </li>
                                        <li>
                                            <p class="table-text"><strong>No:</strong> Does not use the first row as the heading.</p>
                                        </li>
                                    </ul>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Zero day provisioning</p>
                                </td>
                                <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Specify whether you want to&#160;allow birthright access for the users you are uploading.</p>
                                    <p class="table-text">To add a rule&#160;go to  &#160;<strong>Admin &gt; Policies &gt; Technical Rules &gt; Actions &gt; Create Technical Rules</strong>&#160;.</p>
                                    <p class="table-text">The options are:</p>
                                    <ul>
                                        <li>
                                            <p class="table-text"><strong>Yes: </strong>Allows birthright provisioning.&#160;</p>
                                        </li>
                                        <li>
                                            <p class="table-text"><strong>No: </strong>Does not&#160;allow birthright provisioning.</p>
                                        </li>
                                    </ul>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Generate system user name</p>
                                </td>
                                <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Specify whether you want to&#160;generate a system user name for the users you are uploading.</p>
                                    <p class="table-text">To add a rule go to&#160;<strong>Admin &gt; Global Configurations &gt; Identity lifecycle &gt; System Username Generation Rule</strong>.</p>
                                    <p class="table-text">The options are:</p>
                                    <ul>
                                        <li>
                                            <p class="table-text"><strong>Yes: </strong>Generates a system user name</p>
                                        </li>
                                        <li>
                                            <p class="table-text"><strong>No: </strong>Does not generate a system user name.</p>
                                        </li>
                                    </ul>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Generate User Email</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Specify whether you want to&#160;generate an email id&#160;for the users you are uploading.&#160;The format of email is taken from the rule, defined in the&#160;<strong>Email Generation Rule </strong>field.</p>
                                    <p class="table-text">To add a rule go to&#160;<strong>Admin &gt; Global Configurations &gt; Identity lifecycle &gt; Email Generation Rule</strong>.</p>
                                    <p class="table-text">The options are:</p>
                                    <ul>
                                        <li>
                                            <p class="table-text"><strong>Yes: </strong>Generates email id for the users.</p>
                                        </li>
                                        <li>
                                            <p class="table-text"><strong>No: </strong>Does not generate email id.</p>
                                        </li>
                                    </ul>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Check rules</p>
                                </td>
                                <td class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p style="text-align: left;" class="table-text">Specify whether you want to&#160;check&#160;the Identity Access Rules for all the users that you are uploading.</p>
                                    <p style="text-align: left;" class="table-text">The following options are available to select:</p>
                                    <ul>
                                        <li>
                                            <p class="table-text"><strong>Yes: </strong>Select<strong> Yes</strong>&#160;to check the Identity Access Rules for all the uploaded users individually.<br /></p>
                                            <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                                                <p class="note">If you select<strong> Yes</strong>, it will result in additional overhead and will involve going through each of the Identity Access Rules, checking the conditions, comparing them with each user being uploaded and creating a task if the condition matches. </p>
                                            </div>
                                        </li>
                                        <li>
                                            <p class="table-text"><strong>No: </strong>Select<strong> No</strong>to skip checking the Identity Access Rules for all the uploaded users individually. Selecting this option will not check Identity Access Rules and will just upload the user details.</p>
                                        </li>
                                    </ul>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Check Rule For Custom JAR</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p class="table-text">Specify whether you want to enable data validation for all the uploaded users through the Saviynt Extension (custom validation JAR) framework. Use this option only if the path of the extension (JAR) is defined in Global Configurations and the validation rules for user data are defined within the extension.</p>
                                    <p style="text-align: left;" class="table-text">The options are:</p>
                                    <ul>
                                        <li>
                                            <p class="table-text"><strong>Yes: </strong>Enables data validation</p>
                                        </li>
                                        <li>
                                            <p class="table-text"><strong>No: </strong>Skips data validation</p>
                                        </li>
                                    </ul>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyE-Column1-Body1">
                                    <p class="table-text">Reconciliation Field</p>
                                    <p style="text-align: left;" class="table-text">
                                        <br />
                                    </p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyD-Column1-Body1">
                                    <p style="text-align: left;" class="table-text">Specify this parameter to compare the existing users in IGA with the users being uploaded based on certain attributes of users such as username.&#160;<span style="color: rgb(9,30,66);">If the attribute value matches the existing attribute in IGA, the value is updated. Otherwise, it is created.</span></p>
                                    <p style="text-align: left;" class="table-text">By default, this parameter uses the username attribute to match the user's attributes. You can use a different attribute from the provided list based on your requirement.</p>
                                </td>
                            </tr>
                            <tr class="TableStyle-Default-Table-Body-Body1">
                                <td colspan="1" class="TableStyle-Default-Table-BodyB-Column1-Body1">
                                    <p class="table-text">User Pre-processor Config JSON</p>
                                </td>
                                <td colspan="1" class="TableStyle-Default-Table-BodyA-Column1-Body1">
                                    <p>Specify the JSON to normalize the data before it&#160;is imported to IGA using an inline preprocessor. For more information, see&#160;<MadCap:xref href="User-Import-Preprocessor.htm">User Import Preprocessor</MadCap:xref>.</p>
                                    <p>Example:</p>
                                    <MadCap:codeSnippet>
                                        <MadCap:codeSnippetCopyButton aria-label="Copy" title="Copy to clipboard" />
                                        <MadCap:codeSnippetCaption>JSON</MadCap:codeSnippetCaption>
                                        <MadCap:codeSnippetBody MadCap:useLineNumbers="True" MadCap:lineNumberStart="1" MadCap:continue="False" xml:space="preserve" style="padding-left: 12px;padding-right: 16px;padding-top: 12px;padding-bottom: 12px;mc-code-lang: PlainText;">{
  "ADDITIONALTABLES": {
    "USERS": "SELECT customproperty40, PreferedFirstName, customproperty1, customproperty5, customproperty6, entity, locationnumber, startdate, employeetype, customproperty12, customproperty23, customproperty24, customproperty30, customproperty41, customproperty42, customproperty31, customproperty43, customproperty22, systemUsername, Departmentname, Departmentnumber, email, customproperty37, customproperty2, firstname, lastname, middlename, customproperty39, customproperty36, displayName, street, jobcodedesc FROM USERS"  },
  "COMPUTEDCOLUMNS": [
    "customproperty40",
    "displayName",
    "street",
    "jobcodedesc",
    "customproperty41",
    "customproperty42",
    "customproperty43",
    "customproperty23",
    "customproperty24",
    "customproperty37",
    "customproperty30",
    "systemUsername",
    "email",
    "customproperty39",
    "customproperty1",
    "customproperty5",
    "customproperty6",
    "customproperty12",
    "customproperty22",
    "customproperty2",
    "customproperty31",
    "customproperty36"  ],
  "PREPROCESSQUERIES": [
    "UPDATE NEWUSERDATA SET displayName = CONCAT(PreferedFirstName,' ',customproperty1) where (displayName is null or displayName='')",
    "UPDATE NEWUSERDATA SET street = case when (customproperty5 is not null or customproperty5!='') and (customproperty6 is not null or customproperty6!='') and (street is null) then CONCAT(customproperty5,' ',customproperty6) when (customproperty5 is not null or customproperty5!='') and (street is null) then customproperty5 end",
    "UPDATE NEWUSERDATA SET jobcodedesc='OU=Users,OU=CAM,OU=CSC,OU=US,DC=am,DC=cpb,DC=com' where locationnumber in ('9000','9002') AND customproperty22 in ('EN','RD','RDQ','QL','SU','GM','HR','IT','LG','MK','PA','PR','SA','ST','EX','AD','CC','GD','IM','PC','SA','FI') AND Date(startdate) &gt;= DATE(NOW()) and employeetype='Employee' AND customproperty12='A' AND (customproperty23 is null or customproperty23='') AND (customproperty24 is null or customproperty24='') AND (customproperty30 is null or customproperty30='') and jobcodedesc is null"  ]
}</MadCap:codeSnippetBody>
                                    </MadCap:codeSnippet>
                                    <p>
                                    </p>
                                    <div class="note" MadCap:autonum="&lt;b&gt;Note&lt;/b&gt;">
                                        <p class="note">Ensure that you map all the columns in the uploaded CSV file to the&#160;Saviynt attributes in the&#160;<strong style="background-color: rgb(255,255,255);">Upload User Preview</strong> page.</p>
                                    </div>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
            </li>
            <li>Click <strong>Upload and Preview</strong>.</li>
            <li>In <strong>Upload User Preview</strong> page,&#160;click <strong>Import Now</strong>.<br />If you have selected <strong>First row as heading</strong> as <strong>No</strong>, manually map the user file fields to the database users table fields and click <strong>Import Now</strong>.</li>
            <li>
                <p class="auto-cursor-target">If the upload is successful, the uploaded record details are populated in the&#160;<strong>Upload User Summary </strong>page under&#160;the following columns:&#160;<strong>Total No of Records, Total User(s) inserted</strong> and <strong>Total User(s) updated</strong>.</p>
            </li>
            <li>
                <p class="auto-cursor-target">Go to&#160;<strong>Admin &gt; Identity Repository &gt; Users </strong> to view the details of the users uploaded using the CSV file.</p>
            </li>
        </ol>
        <h2>Troubleshooting</h2>
        <p>An exception is encountered when trying to execute the File-based Users Import job.</p>
        <p><strong>Cause</strong>:&#160;Extra space or newline characters may be present in the <strong>MODIFYUSERDATAJSON</strong> value in the SAV file.</p>
        <p><strong>Resolution</strong>: Remove the&#160;spaces and newline characters from <strong>MODIFYUSERDATAJSON </strong>value in the SAV file.&#160;</p>
    </body>
</html>